SystemOrganization addCategory: #EpigentRiakInterfaceCore!

!ZnClient class methodsFor: '*EpigentRiakInterfaceCore' stamp: 'RunarJordahl 2/28/2011 11:10'!
put: urlObject data: entity headers: aBlockClosure
	^ self put: urlObject data: entity withRequestDo: [ :a | a headers addAll: aBlockClosure ]! !

!ZnClient class methodsFor: '*EpigentRiakInterfaceCore' stamp: 'RunarJordahl 2/28/2011 11:11'!
put: urlObject data: entity withRequestDo: aBlockClosure
	| url stream request |
	url := urlObject asZnUrl.
	stream := ZnNetworkingUtils socketStreamToUrl: url.
	(request := ZnRequest put: url) entity: entity.
	aBlockClosure value: request.
	^ self executeOneShot: request on: stream! !

Object subclass: #EpigentRiakClient
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

EpigentRiakClient class
	instanceVariableNames: 'location'!

EpigentRiakClient class
	instanceVariableNames: 'location'!

!EpigentRiakClient class methodsFor: 'instance creation' stamp: 'RunarJordahl 3/2/2011 20:05'!
newForLocation: urlString
	^ self new connection: (EpigentRiakRestConnection newWithLocation: urlString)! !

!EpigentRiakClient methodsFor: 'accessing' stamp: 'RunarJordahl 2/28/2011 20:22'!
bucketNamed: aString
	^ EpigentRiakBucket newFor: self withBucketName: aString! !

!EpigentRiakClient methodsFor: 'accessing' stamp: 'RunarJordahl 2/28/2011 20:36'!
bucketNames

	^self connection bucketNames! !

!EpigentRiakClient methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 16:21'!
connection

	^ connection! !

!EpigentRiakClient methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 16:21'!
connection: anObject

	connection := anObject! !

Object subclass: #EpigentRiakClientOwned
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

EpigentRiakClientOwned subclass: #EpigentRiakBucket
	instanceVariableNames: 'bucketName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

!EpigentRiakBucket class methodsFor: 'instance creation' stamp: 'RunarJordahl 2/28/2011 20:20'!
newFor: client withBucketName: aString
	^ (self new)
		client: client;
		bucketName: aString;
		yourself! !

!EpigentRiakBucket methodsFor: 'accessing database' stamp: 'RunarJordahl 3/2/2011 22:56'!
atKey: keyName
	^ self client connection dataInBucket: self bucketName forKey: keyName! !

!EpigentRiakBucket methodsFor: 'action database' stamp: 'RunarJordahl 2/28/2011 20:49'!
atKey: keyName put: data type: typeString
	^ self client connection
		bucketNamed: self bucketName
		key: keyName
		put: data
		type: typeString! !

!EpigentRiakBucket methodsFor: 'accessing' stamp: 'RunarJordahl 2/28/2011 20:17'!
bucketName
	^ bucketName! !

!EpigentRiakBucket methodsFor: 'accessing' stamp: 'RunarJordahl 2/28/2011 20:17'!
bucketName: anObject
	bucketName := anObject! !

!EpigentRiakBucket methodsFor: 'action database' stamp: 'RunarJordahl 3/2/2011 12:19'!
deleteKey: keyName
	^ self client connection bucketNamed: self bucketName deleteKey: keyName! !

!EpigentRiakClientOwned methodsFor: 'accessing' stamp: 'RunarJordahl 2/28/2011 20:20'!
client
	^ client! !

!EpigentRiakClientOwned methodsFor: 'accessing' stamp: 'RunarJordahl 2/28/2011 20:20'!
client: anObject
	client := anObject! !

Object subclass: #EpigentRiakRestConnection
	instanceVariableNames: 'location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

!EpigentRiakRestConnection class methodsFor: 'instance creation' stamp: 'RunarJordahl 3/2/2011 19:42'!
newWithLocation: urlString
	^ (self new)
		location: urlString;
		yourself! !

!EpigentRiakRestConnection methodsFor: 'action database' stamp: 'RunarJordahl 3/2/2011 20:25'!
bucketNamed: bucketName deleteKey: keyName
	| url response |
	url := self location , '/' , bucketName , '/' , keyName.
	response := ZnClient delete: url.
	^ response! !

!EpigentRiakRestConnection methodsFor: 'action database' stamp: 'RunarJordahl 3/2/2011 20:25'!
bucketNamed: bucketName key: keyName put: data type: typeString
	| url response |
	url := self location , '/' , bucketName , '/' , keyName.
	response := ZnClient
		put: url
		data: (ZnEntity with: data type: typeString)
		headers:
			((Dictionary new)
				at: 'X-Riak-Meta-Test' put: 't';
				yourself).
	^ response! !

!EpigentRiakRestConnection methodsFor: 'accessing database' stamp: 'RunarJordahl 3/2/2011 20:25'!
bucketNames
	| url response |
	url := self location , '?buckets=true'.
	response := ZnClient get: url.
	^ (Json readFrom: response contents readStream) at: 'buckets'! !

!EpigentRiakRestConnection methodsFor: 'accessing database' stamp: 'RunarJordahl 3/2/2011 22:59'!
dataInBucket: bucketName forKey: key
	| url response |
	url := self location , '/' , bucketName , '/' , key.
	response := ZnClient get: url.
	^ response contents! !

!EpigentRiakRestConnection methodsFor: 'initialize-release' stamp: 'RunarJordahl 2/28/2011 19:22'!
initialize
	super initialize.
	self location: 'http://localhost:8098'! !

!EpigentRiakRestConnection methodsFor: 'accessing - private' stamp: 'RunarJordahl 2/13/2011 18:17'!
location
	^ location! !

!EpigentRiakRestConnection methodsFor: 'accessing - private' stamp: 'RunarJordahl 3/3/2011 18:28'!
location: urlString
	location := urlString! !
